## [2.11.3]
- Type parameters and added docs

## [2.11.2]
- Added docs
- Improvement performance of Obx

## [2.11.1]
- Fixed: oninit calling only once.

## [2.11.0]
- Added Permissions:
You can now revoke permissions to SmartManagement so that it cannot delete a particular controller.
Add to Get.put (Controller(), permanent: true); to make it indelible.
Get.lazyPut () will not receive this resource. Initially he had it, but we saw in internal tests that it could cause problems with the bindings API. Bindings were created to initialize and delete an instance, if it were allowed to make a controller started with lazyPut permanent, copies of that Controller would be created every time Binding was called. For the safety of users, especially new users who could easily do this, it was decided that this feature will only be present in Get.put.
- Improve: Now a controller's life cycle has no connection with the View life cycle. It is no longer called internally in an "initState", it is now called when the Controller enters memory. This means that now onInit will always be called, regardless of where you started your dependency.
- removed: this property of the update() method has been permanently removed.

## [2.10.3]
- GetBuilder refactor. 11% reduction in RAM consumption and 2% in CPU consumption for the sample application. (using as base Flutter for linux desktop).

- The "this" property of the "update" method has been deprecated and will be removed in the next update. Please don't use it anymore. Just use "update()" now.

## [2.10.2]
- Fix Get.generalDialog default options

## [2.10.1]
- Fix broken links on pub
- Fix List empty error

## [2.10.0]
- Added SmartManagement, your application's memory is managed intelligently like never before!
- Added Obx, a widget that knows when to rebuild a child, without needing any type.
- Added MIxinBuilder - If you need to use GetBuilder in conjunction with GetX, use GetController with this widget, and the changes will occur either using update (this) or changing some reactive variable. Use only if necessary, for better RAM consumption, prefer widgets in that order:
Obx => GetX => GetBuilder => MixinBuilder.
Obx is the lightest of all, and MixinBuilder is a mix of the other 3, whenever possible, use the specific widget.
- Refactor: refactor StateManager of Get.
- Changed: full List API refactor, now value is no longer needed.
- Added Workers: You can hear changes to a variable and trigger custom callbacks.
- Added Bindings API docs.

# [2.7.1]
- Improve list to set and get methods

## [2.7.0]
- Added obx, a simple state interceptor. 
- Improve Bindings, ListX, and fix docs typos

## [2.6.3]
- Flutter currently has a problem on some devices where using showModalBottomSheet() can cause TextFields to be hidden behind the keyboard (https://github.com/flutter/flutter/issues/18564) this issue is closed, even users reporting that the problem still occurs.
The problem happens casually, as well as the problem of the snackbar on the iPhone SE 2, and checking the code, I realized that a padding with MediaQuery.of(context).viewInsets.bottom is missing inside the bottomSheet to make it work correctly, since it does not have any constraint with the keyboard.
For stability, I decided not to use the standard Flutter bottomSheet, which contains many bugs, mainly related to keyboard padding, and the lack of respect for topBar's safeArea, and to use a proprietary bottomSheet implementation that is more stable. The Flutter dialog has no problem, so it will be used as the basis for Get.dialog. The bottomSheet will be based on the Flutter bottomSheet Raw API (_ModalBottomSheetRoute), applying bug fixes.
- Added Get.isSnackbarOpen tests

## [2.6.2]
- Refactor Bindings API

## [2.6.1]
- Expose Bindings API

## [2.6.0]
- Added bindings.
You can now add bindings from your controllers to your routes, to prepare GetBuilder or GetX to create a dependency already declared in a Binding class. This feature is in an experimental phase, and will not be documented until the end of the tests.

## [2.5.10]
- Removed remnants of previousArgs on routeObserver.
This feature had been deprecated in previous updates, and was removed in version 2.5.8. Some remaining references on the routeObserver were causing exceptions in version 2.5.9, and were removed completely in version 2.5.10.

## [2.5.9]
- Fix Get.find with named instance

## [2.5.8]
- Added docs

## [2.5.7]
- Fix Get.generalDialog optionals
- Added GetX onInit support

## [2.5.6]
- GetBuilder refactor to work with lazyPut.
Now you can list your controllers in advance with Get.lazyPut, and only when it is called for the first time will it be relocated in memory.

## [2.5.5]
- Fix arguments broken by new methods

## [2.5.4]
- Refactor methods

## [2.5.3]
- Fix snackbar padding on iPhone SE 2.
- Added themes docs

## [2.5.2]
- Fix: key not found when Get.key is used with no MaterialApp

## [2.5.1]
- Improve - GetBuilder uses 18% less ram on more of 20 controllers.

## [2.5.0]
- Added List.obs
- Now you can transform any class on obs

## [2.4.0] 
- Added GetX, state manager rxDart based. 
- Fix error on add for non global controllers

## [2.3.2] 
- Fix close method called on not root GetBuilder

## [2.3.1] 
- Auto close stream inside close method
- Added docs

## [2.3.0] 
- Added interface to GetX support

## [2.2.8] 
- Added api to platform brightness

## [2.2.7] 
- Fix typos

## [2.2.6] 
- Fix cancel button on defaultDialog don't appear when widget implementation usage

## [2.2.5] 
- Refator defaultDialog

## [2.2.4] 
- Clean code
- Fix Get.LazyPut

## [2.2.3] 
- Remove defaultDialog type

## [2.2.2] 
- Fix GetRoute not found

## [2.2.1] 
- Improve lazyPut

## [2.2.0] 
- Added: Ability to choose or delay a widget's state change according to its ID.
- Added: Ability to fire triggers when loading materialApp.
- Added: Ability to change theme dynamically.
- Added: Ability to rebuild the entire app with one command.
- Added: Ability to trigger events on the MaterialApp.
- Added: Get.lazyPut (lazy loading of dependencies).
- Added: Get.creator - a factory of dependencies .
- Added: Capability of define abstract class on dependencies. 

## [2.1.2] 
- Get.defaultDialog refactor

## [2.1.1] 
- fix typo

## [2.1.0] 
- Added Get.rawSnackbar
- Added instantInit config to snackbars
- Refactor Get Instance Manager
- Improved performance and bug fix to Get State Manager 
- Improved performance of GetRoute on namedRoutes
- Hotfix on namedRoutes

## [2.0.10] 
- Bump new Flutter version
- Added Get.generalDialog

## [2.0.6] 
- Fix typo on readme

## [2.0.5] 
- Changing the bottomsheet API to comply with the documentation.

## [2.0.4] 
- Fix type not found in some versions of Flutter stable

## [2.0.3] 
- Update Docs

## [2.0.2] 
- Update GetObserver

## [2.0.1] 
- Fix docs and typos

## [2.0.0] 
- Added easy state manager
- Change dialog API 
- Added GetMaterialApp 
- Added new experimental APIs 
- Improve Observer 
- Added default duration on Transitions 
- Added new routeNamed sistem
- Added Global stateManager config 
- Improve Get instance manager 
- Added routingCallback 
- Added closeOverlays to Get.back 
- Added dynamic urls 
- Cleaner code
- Improve lib performance 
- Many others minor APIs added

## [1.20.1] 
- Improve: Get.finds

## [1.20.0] 
- Added Get Instance Manager
  Get.put / Get.find / Get.delete

## [1.19.1] 
- Fix default transitions for namedRoutes

## [1.19.0] 
- Added nested navigators

## [1.18.0] 
- Added SafeArea to bottomsheets
- Added docs

## [1.17.0] 
- Added experimental APIs


## [1.16.1] 
- Improve: GetObserver

## [1.16.0-dev] 
- Added Get config
- Added logEnable 
- Added Default transition 
- Added default popGesture behaviour 
- Added overlayContext 
- Fix Duration transition

## [1.14.1-dev] 
- Fix ternary on new dart version

## [1.14.0-dev] 
- Added compatibility with Flutter 1.17.1
- Added back popGesture to iOS (default) and Android (optional)
- Improve performance
- Decrease lib size to 94.9kb (25.4k after compiled on release)

## [1.13.1-dev] 
- Fix back function

## [1.13.0-dev] 
- Plugin refactor
- Added GetPlatform

## [1.12.0-dev] 
-Compatibility with Dev branch

## [1.11.4] 
- Refactor code of library

## [1.11.3] 
-Added docs


## [1.11.2] 
 -Fix flutter web platform and added GetPlatform

## [1.11.1] 
 -Improve swipe to back on iOS devices

 ## [1.11.0] 
 -Added experimental GetCupertino

## [1.10.5] 
 -Added setKey to improve modular compatibility
 -Added ability to define transition duration directly when calling the new route.

## [1.10.4] 
 -Improve Get.offAll() - predicate now is optional

## [1.10.3] 
 -Improve default color from dialogs

 ## [1.10.2] 
 -Improve snackbar text color

 ## [1.10.1] 
 -Backdrop improvement

## [1.10.0] 
 -Added backdrop

## [1.9.2] 
 -Added docs to GetObserver

 ## [1.9.1] 
 -Fix typo on snackbar route

## [1.9.0] 
 -Added: Navigator observer 
 -Added: Get.args to named routes 
 -Improve snackbar performance 

## [1.8.1] 
 -Fix new snackbar features

## [1.8.0] 
 -Add Get.close method.
 -Add many Snackbars features

## [1.7.4] 
 -Fix dialog child error

## [1.7.3] 
 -Added transitions docs

## [1.7.2] 
 -Fix bottomsheet on macos

## [1.7.1] 
 -Fix docs

## [1.7.0] 
   
 - Improve geral performance. Get.to Wrap now consumes even less RAM and CPU. In an application with 20 screens, it obtained 82% less RAM usage compared to the traditional method Navigator.push and had a CPU normalization of 23% in a Moto z2, against 64% CPU usage in Navigator.push with MaterialPageRoute. Test it for yourself!
 - Added BottomSheet with no context 
 - Added modern Blur Snackbar
 - Added customs transitions
 - Improve dialogs performance

## [1.6.4] 
   
 - Improve performance. 

## [1.6.3] 
   
 - Clean code. 

## [1.6.2] 
   
 - Fix bugs on blurred Snackbars

## [1.6.1] 
   
 - Add docs and improve performance
 
## [1.6.0] 
   
 - Add support to snackbars

## [1.5.0+1] 
  
 - Add color and opacity to dialogs
 
## [1.5.0] 
  
 - Add support to dialogs

## [1.4.0+7] 
 
 - Add more documentation

## [1.4.0+6] 

- Improve performance and bug fix 

## [1.4.0] 

- Added Get.removeRoute // ability to remove one route. 
        Get.until // back repeatedly until the predicate returns true.
        Get.offUntil // go to next route and remove all the previous routes until the predicate returns true.
        Get.offNamedUntil // go to next named route and remove all the previous routes until the predicate returns true.
        
## [1.3.4] 

- Improve performance

## [1.3.3] 

- Fix Get.back arguments

## [1.3.2] 

- Improve performance

## [1.3.1] 

- Update docs

## [1.3.0] 

- Update docs, readme, and add full support to flutter_web

## [1.2.1] 

- Fix bug currentState = null


## [1.2.0] 

- Add routes navigation with no context

## [1.1.0] 

- Add support to named routes 

## [1.0.3] 

- Improve Performance

## [1.0.2] 

- Add examples

## [1.0.1] 

- Doc changes

## [1.0.0] 

- initial release
