import 'package:flutter/widgets.dart';
import 'package:get/src/platform/platform.dart';
import 'package:get/src/routes/transitions_type.dart';

import 'smart_management.dart';

class GetConfig {

  static bool defaultPopGesture = GetPlatform.isIOS;
  static bool defaultOpaqueRoute = true;
  static Transition defaultTransition =
      (GetPlatform.isIOS ? Transition.cupertino : Transition.fade);
  static Duration defaultDurationTransition = Duration(milliseconds: 400);
  static bool defaultGlobalState = true;
  static RouteSettings settings;
  static SmartManagement smartManagement = SmartManagement.full;
  static bool logEnable = true;
  static config(
      {bool enableLog,
      bool defaultPopGesture,
      bool defaultOpaqueRoute,
      Duration defaultDurationTransition,
      bool defaultGlobalState,
      Transition defaultTransition}) {
    if (enableLog != null) {
      GetConfig.logEnable = enableLog;
    }
    if (defaultPopGesture != null) {
      GetConfig.defaultPopGesture = defaultPopGesture;
    }
    if (defaultOpaqueRoute != null) {
      GetConfig.defaultOpaqueRoute = defaultOpaqueRoute;
    }
    if (defaultTransition != null) {
      GetConfig.defaultTransition = defaultTransition;
    }

    if (defaultDurationTransition != null) {
      GetConfig.defaultDurationTransition = defaultDurationTransition;
    }

    if (defaultGlobalState != null) {
      GetConfig.defaultGlobalState = defaultGlobalState;
    }
  }
}
